/* AX25 control commands
 * Copyright 1991 Phil Karn, KA9Q
 * 
 * Mods by G1EMM
 * Mods by PA0GRI
 * Mods by N1BEE
 */
/*
** FILE: ax25cmd.c
**
** AX.25 command handler.
**
** 09/24/90 Bob Applegate, wa2zzx
**    Added BCTEXT, BC, and BCINTERVAL commands for broadcasting an id
**    string using UI frames.
**
** 27/09/91 Mike Bilow, N1BEE
**    Added Filter command for axheard control
*/

#ifdef MSDOS
#include <dos.h>
#endif
#include "global.h"
#ifdef AX25
#include "mbuf.h"
#include "timer.h"
#include "proc.h"
#include "iface.h"
#include "ax25.h"
#include "lapb.h"
#include "cmdparse.h"
#include "socket.h"
#include "mailbox.h"
#include "session.h"
#include "tty.h"
#include "nr4.h"
#include "commands.h"
#include "pktdrvr.h"
#include "netrom.h" 
#ifdef POOLED
#include "pool.h"
#endif

int axheard __ARGS((struct iface *ifp));
static int doaxfilter __ARGS((int argc,char *argv[],void *p));
static int doaxflush __ARGS((int argc,char *argv[],void *p));
static int doaxirtt __ARGS((int argc,char *argv[],void *p));
static int doaxkick __ARGS((int argc,char *argv[],void *p));
static int doaxreset __ARGS((int argc,char *argv[],void *p));
static int doaxroute __ARGS((int argc,char *argv[],void *p));
int doaxstat __ARGS((int argc,char *argv[],void *p));
static int doaxwindow __ARGS((int argc,char *argv[],void *p));
static int dobc __ARGS((int argc,char *argv[],void *p));
static int dobcint __ARGS((int argc,char *argv[],void *p));
static int dobcport __ARGS((int argc,char *argv[],void *p));
static int dobctext __ARGS((int argc,char *argv[],void *p));
static int doaxhport __ARGS((int argc,char *argv[],void *p));
static int doaxhsize __ARGS((int argc,char *argv[],void *p));
static int doblimit __ARGS((int argc,char *argv[],void *p));
static int doaxuser __ARGS((int argc,char *argv[],void *p));
static int dodigipeat __ARGS((int argc,char *argv[],void *p));
static int domaxframe __ARGS((int argc,char *argv[],void *p));
static int domycall __ARGS((int argc,char *argv[],void *p));
static int don2 __ARGS((int argc,char *argv[],void *p));
static int dopaclen __ARGS((int argc,char *argv[],void *p));
static int dopthresh __ARGS((int argc,char *argv[],void *p));
static int dot3 __ARGS((int argc,char *argv[],void *p));
static int doaxtype __ARGS((int argc,char *argv[],void *p));
static int dot4 __ARGS((int argc,char *argv[],void *p));
static int doaxversion __ARGS((int argc,char *argv[],void *p));
static int doaxmaxwait __ARGS((int argc,char *argv[],void *p));
static int dosmartroute __ARGS((int argc,char *argv[],void *p));
#ifdef TUTOR
static int dotutorcall __ARGS((int argc,char *argv[],void *p));
static int doinfocall __ARGS((int argc,char *argv[],void *p));
static int donewscall __ARGS((int argc,char *argv[],void *p));
#endif
static int dorosecall __ARGS((int argc,char *argv[],void *p));
static int docall __ARGS((int argc,char *argv[],void *p,char call[]));
void dobroadtick __ARGS((void));
int donralias __ARGS((int argc,char *argv[],void *p));
#ifdef AXBCSTR
static void ax_bc __ARGS((struct iface *axif, char *str));
#else
static void ax_bc __ARGS((struct iface *axif));
#endif
static int axdest __ARGS((struct iface *ifp));
#ifdef TTYCALL
static int dottycall __ARGS((int argc, char *argv[], void *p));
extern char Ttycall[AXALEN];	/* the ttylink call in 'call' form */
#endif
#ifdef TUTOR
static int docall __ARGS((int argc,char *argv[],void *p,char call[]));
#endif
#ifdef MAILBOX
extern void setmbnrid __ARGS((void));
int dombports __ARGS((int argc,char *argv[],void *p));
#endif

static int doax25paclen __ARGS((int argc, char *argv[], void *p));
static int doax25timertype __ARGS((int argc, char *argv[], void *p));
static int doax25irtt __ARGS((int argc, char *argv[], void *p));
static int doax25version __ARGS((int argc, char *argv[], void *p));
static int doax25t3 __ARGS((int argc, char *argv[], void *p));
static int doax25t4 __ARGS((int argc, char *argv[], void *p));
static int doax25n2 __ARGS((int argc, char *argv[], void *p));
static int doax25maxframe __ARGS((int argc, char *argv[], void *p));
static int doax25pthresh __ARGS((int argc, char *argv[], void *p));
static int doax25window __ARGS((int argc, char *argv[], void *p));
static int doax25blimit __ARGS((int argc, char *argv[], void *p));
static int doax25maxwait __ARGS((int argc, char *argv[], void *p));


long Axmaxwait;


extern int axheard_filter_flag;		/* in axheard.c */
/* Defaults for IDing. */
char *axbctext = NULL;				/* Text to send */
static struct timer Broadtimer;	/* timer for broadcasts */
extern char Tcall[AXALEN];
extern char Icall[AXALEN];
extern char Ncall[AXALEN];
extern char Myalias[AXALEN];
extern char Nralias[ALEN+1];
char AXRosecall[AXALEN];
int AXSmartRoute = 0;
extern int lapbtimertype;


#ifdef CATALOG
#include "catalog.h"

#define CAT ax25cmd_catalog

#define smartroute	__STR(0)
#define badalias	__STR(1)
#define noiface		__STR(2)
#define notax25		__STR(3)
#define bcaststr	__STR(4)
#define bcasttimer	__STR(5)
#define maxheard	__STR(6)
#define alsonotax25	__STR(7)
#define notactive	__STR(8)
#define heardheader	__STR(9)
#define heardheader2	__STR(10)
#define destheader	__STR(11)
#define heardfilter	__STR(12)
#define filterusage	__STR(13)
#define filtersrc	__STR(14)
#define filterdest	__STR(15)
#define stopstr		__STR(16)
#define lumsstr		__STR(17)
#define srttmdev	__STR(18)
#define T1_4str		__STR(19)
#define blimitstr	__STR(20)
#define maxwaitstr	__STR(21)
#define axversionstr	__STR(22)
#define irttstr		__STR(23)
#define polltimerstr	__STR(24)
#define redundancystr	__STR(25)
#define retrylimitstr	__STR(26)
#define maxframestr	__STR(27)
#define paclenstr	__STR(28)
#define pthreshstr	__STR(29)
#define windowstr	__STR(30)
#define badcallsign	__STR(31)
#define toomany		__STR(32)
#define baddigi		__STR(33)
#define addfailed	__STR(34)
#define routeheader	__STR(35)
#define routeusage	__STR(36)
#define badtarget	__STR(37)
#define notintable	__STR(38)
#define timertypestr	__STR(39)
#define timertypeusage	__STR(40)
#define bctext_str	__STR(41)

#else /* CATALOG */

static const char DFAR smartroute[] = "AX25 Smart Routing";
static const char DFAR badalias[] = "can't set alias\n";
static const char DFAR noiface[] = "you need to specify an interface\n";
static const char DFAR notax25[] = "not an AX.25 interface\n";
static const char DFAR bcaststr[] = "Broadcast text: %s\n";
static const char DFAR bcasttimer[] = "Broadcast timer %lu/%lu seconds\n";
static const char DFAR maxheard[] = "Max ax-heard";
static const char DFAR alsonotax25[] = "Interface %s not AX.25 type interface\n";
static const char DFAR notactive[] = "not active\n";
static const char DFAR heardheader[] = "Interface  Station   Time since send  Pkts sent\n";
static const char DFAR heardheader2[] = "Station   Time since heard Pkts rcvd : Station   Time since heard Pkts rcvd\n";
static const char DFAR destheader[] = "Station   Last ref         Last heard           Pkts\n";
static const char DFAR heardfilter[] = "ax25 heard filter";
static const char DFAR filterusage[] = "Usage: ax25 filter <0|1|2|3>\n";
static const char DFAR filtersrc[] = "Callsign logging by source %sabled, ";
static const char DFAR filterdest[] = "by destination %sabled\n";
static const char DFAR stopstr[] = "stop";
static const char DFAR lumsstr[] = "/%lu ms; ";
static const char DFAR srttmdev[] = "srtt = %lu mdev = %lu ";
static const char DFAR T1_4str[] = "T%c: ";
static const char DFAR blimitstr[] = "blimit";
static const char DFAR maxwaitstr[] = "retry maxwait";
static const char DFAR axversionstr[] = "AX25 version";
static const char DFAR irttstr[] = "Initial RTT (ms)";
static const char DFAR polltimerstr[] = "Idle poll timer (ms)";
static const char DFAR redundancystr[] = "Link redundancy timer (sec)";
static const char DFAR retrylimitstr[] = "Retry limit";
static const char DFAR maxframestr[] = "Window size (frames)";
static const char DFAR paclenstr[] = "Max frame length (bytes)";
static const char DFAR pthreshstr[] = "Poll threshold (bytes)";
static const char DFAR windowstr[] = "AX25 receive window (bytes)";
static const char DFAR badcallsign[] = "Bad callsign %s\n";
static const char DFAR toomany[] = "Too many digipeaters\n";
static const char DFAR baddigi[] = "Bad digipeater %s\n";
static const char DFAR addfailed[] = "Route add failed\n";
static const char DFAR routeheader[] = "Target    Iface  Type  Mode Digipeaters\n";
static const char DFAR routeusage[] = "Usage: ax25 route add <target> <iface> [digis...]\n       ax25 route drop <target> <iface>\n       ax25 route mode <target> <iface> [mode]\n";
static const char DFAR badtarget[] = "Bad target %s\n";
static const char DFAR notintable[] = "Not in table\n";
static const char DFAR timertypestr[] = "AX25 timer type is ";
static const char DFAR timertypeusage[] = "use: ax25 timertype [original|linear|exponential]\n";
static const char DFAR bctext_str[] = "Bctext : %s\n";
#endif /* CATALOG */

static const char DFAR strCR[] = "%s\n";
static const char DFAR heardfmt[] = "%-9s  %-9s   %12s    %7lu\n";
static const char DFAR str17[] = "%-17s";
static const char DFAR axstatheader[] = 
#if defined(UNIX) || defined(TNOS_68K)
	"&AXB     Snd-Q   Rcv-Q   Remote    Local     Iface  State\n";
#else
	"&AXB Snd-Q   Rcv-Q   Remote    Local     Iface  State\n";
#endif
static const char DFAR axstatfmt[] =
#if defined(UNIX) || defined(TNOS_68K)
	"%8.8lx %-8d%-8d%-10s%-10s%-7s%s\n";
#else
	"%4.4x %-8d%-8d%-10s%-10s%-7s%s\n";
#endif
static const char DFAR axcbheader[] = 
#if defined(UNIX) || defined(TNOS_68K)
	"&AXB     Local     Remote    Iface  RB V(S) V(R) Unack P Retry State\n";
#else
	"&AXB Local     Remote    Iface  RB V(S) V(R) Unack P Retry State\n";
#endif
static const char DFAR axcbfmt[] = 
#if defined(UNIX) || defined(TNOS_68K)
	"%8.8lx %-9s %-9s %-6s %c%c";
#else
	"%4.4x %-9s %-9s %-6s %c%c";
#endif
static const char DFAR lustr[] = "%lu";
static const char DFAR unknownmode[] = "Unknown mode %s\n";
static const char DFAR unknowncmd[] = "Unknown command %s\n";
static const char DFAR originalstr[] = "original\n";
static const char DFAR linearstr[] = "linear\n";
static const char DFAR exponentialstr[] = "exponential\n";


const char * DFAR Ax25states[] = {
	"",
	"Disconnected",
	"Listening",
	"Conn pending",
	"Disc pending",
	"Connected",
	"Recovery",
};

/* Ascii explanations for the disconnect reasons listed in lapb.h under
 * "reason" in ax25_cb
 */
const char * DFAR Axreasons[] = {
	"Normal",
	"DM received",
	"Timeout"
};

static struct cmds DFAR Axcmds[] = {
	{ "alias",	donralias,	0, 0, NULLCHAR },
	{ "bc",		dobc,		0, 0, NULLCHAR },
	{ "bcinterval",	dobcint,	0, 0, NULLCHAR },
	{ "bcport",	dobcport,	0, 0, NULLCHAR },
	{ "blimit",	doblimit,	0, 0, NULLCHAR },
	{ "bctext",	dobctext,	0, 0, NULLCHAR },
	{ "dest",	doaxdest,	0, 0, NULLCHAR },
	{ "digipeat",	dodigipeat,	0, 0, NULLCHAR },
	{ "filter",	doaxfilter,	0, 0, NULLCHAR },
	{ "flush",	doaxflush,	0, 0, NULLCHAR },
	{ "heard",	doaxheard,	0, 0, NULLCHAR },
	{ "hearddest",	doaxdest,	0, 0, NULLCHAR },
	{ "hport",	doaxhport,	0, 0, NULLCHAR },
	{ "hsize",	doaxhsize,	0, 0, NULLCHAR },
#ifdef TUTOR
	{ "infocall",	doinfocall,     0, 0, NULLCHAR },
#endif
	{ "irtt",	doaxirtt,	0, 0, NULLCHAR },
	{ "kick",	doaxkick,	0, 2, "ax25 kick <axcb>" },
	{ "maxframe",	domaxframe,	0, 0, NULLCHAR },
	{ "maxwait",	doaxmaxwait,	0, 0, NULLCHAR },
	{ "mycall",	domycall,	0, 0, NULLCHAR },
#ifdef TUTOR
	{ "newscall",	donewscall,     0, 0, NULLCHAR },
#endif
	{ "paclen",	dopaclen,	0, 0, NULLCHAR },
	{ "pthresh",	dopthresh,	0, 0, NULLCHAR },
	{ "reset",	doaxreset,	0, 2, "ax25 reset <axcb>" },
	{ "retry",	don2,		0, 0, NULLCHAR },
	{ "rosecall",	dorosecall,	0, 0, NULLCHAR },
	{ "route",	doaxroute,	0, 0, NULLCHAR },
	{ "smartroute",	dosmartroute,	0, 0, NULLCHAR },
	{ "status",	doaxstat,	0, 0, NULLCHAR },
	{ "t3",		dot3,		0, 0, NULLCHAR },
	{ "t4",		dot4,		0, 0, NULLCHAR },
	{ "timertype",	doaxtype,	0, 0, NULLCHAR },
#ifdef TUTOR
	{ "tutorcall",	dotutorcall,    0, 0, NULLCHAR },
#endif
#ifdef TTYCALL
	{ "ttycall",	dottycall,	0, 0, NULLCHAR },
#endif
	{ "user",	doaxuser,	0, 0, NULLCHAR },
	{ "version",	doaxversion,	0, 0, NULLCHAR },
	{ "window",	doaxwindow,	0, 0, NULLCHAR },
	{ NULLCHAR },
};


/* Multiplexer for top-level ax25 command */
int
doax25(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return subcmd(Axcmds,argc,argv,p);
}



int
dosmartroute(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
    return setbool(&AXSmartRoute,smartroute,argc,argv);
}


#ifdef MAILBOX
#include "mailbox.h"
#endif

int
donralias(argc,argv,p)
int argc ;
char *argv[] ;
void *p OPTIONAL;
{
    char tmp[AXBUF];

    if(argc < 2) {
	tprintf(strCR,pax25(tmp,Myalias));
	return 0;
    }
    if( (setcall(Myalias,argv[1]) == -1)
#ifdef NETROM
       || (putalias(Nralias,argv[1],1) == -1)
#endif
					     ){
	    tputs(badalias);
	    Myalias[0] = '\0';
#ifdef NETROM
	    Nralias[0] = '\0';
#endif
	    return 0;
    }
#ifdef MAILBOX
    setmbnrid();
#endif
    return 0;
}

/*
** This function is called to send the current broadcast message
** and reset the timer.
*/

static int dobc(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	struct iface *ifa;

	if (argc < 2)	{
		tputs(noiface);
		return 1;
	}

	if((ifa=if_lookup(argv[1])) == NULLIF)
		tprintf(Badinterface,argv[1]);
	else if (ifa->type != CL_AX25)
		tputs(notax25);
#ifdef AXBCSTR
	else if (argc > 2)
		ax_bc(ifa, argv[2]);
#endif
	else	{
#ifdef AXBCSTR
		ax_bc(ifa, ifa->ax25->bctext);
#else
		ax_bc(ifa);
#endif
		stop_timer(&Broadtimer) ;	/* in case it's already running */
		start_timer(&Broadtimer);		/* and fire it up */
	}
	return 0;
}



/*
** View/Change the message we broadcast.
*/

static int dobctext(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
struct iface *ifp;

	if (argc < 2)
		tprintf(bcaststr,axbctext);
	else	{
		if (axbctext != NULL) free(axbctext);
		axbctext = strdup(argv[1]);
		/* Set all ax.25 interfaces with no bc text */
		for(ifp=Ifaces;ifp->next;ifp=ifp->next)
			if(ifp->type == CL_AX25 && ifp->ax25->bctext == NULL)
				ifp->ax25->bctext = strdup(axbctext);
	}
	return 0;
}


#define TICKSPERSEC	(1000L / MSPTICK)	/* Ticks per second */

/*
** Examine/change the broadcast interval.
*/

static int dobcint(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	if(argc < 2)	{
		tprintf(bcasttimer,
			read_timer(&Broadtimer)/1000L,
			dur_timer(&Broadtimer)/1000L);
		return 0;
	}
	stop_timer(&Broadtimer) ;	/* in case it's already running */
	Broadtimer.func = (void (*)__ARGS((void*)))dobroadtick;/* what to call on timeout */
	Broadtimer.arg = NULLCHAR;		/* dummy value */
	set_timer(&Broadtimer,atoi(argv[1])*1000L);	/* set timer duration */
	start_timer(&Broadtimer);		/* and fire it up */
	return 0;
}

int Maxax25heard;

/* Configure a port to do ax.25 beacon broadcasting */
static int
dobcport(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return(dosetflag(argc,argv,p,AX25_BEACON, 1));
}

/* Set the size of the ax.25 heard list */
int doaxhsize(argc, argv, p)
int argc;
char *argv[];
void *p;
{
    if(argc > 1)                 /* if setting new size ... */
        doaxflush(argc,argv,p);  /* we flush to avoid memory problems - K5JB */
    return setint(&Maxax25heard,maxheard,argc,argv);
}

/* Configure a port to do ax.25 heard logging */
static int
doaxhport(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return(dosetflag(argc,argv,p,LOG_AXHEARD, 1));
}

void
dobroadtick()
{
	struct iface *ifa;

	ifa = Ifaces;

	while (ifa != NULL)	{
	        if (ifa->flags & AX25_BEACON)
#ifdef AXBCSTR
			ax_bc(ifa, ifa->ax25->bctext);
#else
			ax_bc(ifa);
#endif
		ifa = ifa->next;
	}

	/* Restart timer */
	start_timer(&Broadtimer) ;
}



/*
** This is the low-level broadcast function.
*/

#ifdef AXBCSTR
static void ax_bc(axif, theaxbctext)
char *theaxbctext;
#else
static void ax_bc(axif)
#endif
struct iface *axif;
{
	struct mbuf *hbp;
	int i;
#ifndef AXBCSTR
	char *theaxbctext = axif->ax25->bctext;
#endif
	/* prepare the header */
	if ((theaxbctext == NULLCHAR) || !(i = strlen(theaxbctext)))
		return;
	
	if((hbp = alloc_mbuf(i)) == NULLBUF)
		return;
		
	hbp->cnt = i;	
	memcpy(hbp->data,theaxbctext,(size_t)i);

    (*axif->output)(axif, Ax25multi[IDCALL], axif->hwaddr,
		PID_NO_L3, hbp);	/* send it */

	/*
	** Call another function to reset the timer...
	reset_bc_timer();
	*/
}


int
doaxheard(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	struct iface *ifp;

	if(argc > 1){
		if((ifp = if_lookup(argv[1])) == NULLIF){
			tprintf(Badinterface,argv[1]);
			return 1;
		}
		if(ifp->output != ax_output){
			tprintf(alsonotax25,argv[1]);
			return 1;
		}
		if(ifp->flags & LOG_AXHEARD)
			axheard(ifp);
		else
			tputs(notactive);
		return 0;
	}
	for(ifp = Ifaces;ifp != NULLIF;ifp = ifp->next){
		if(ifp->output != ax_output)
			continue;	/* Not an ax.25 interface */
		if(axheard(ifp) == EOF)
			break;
	}
	return 0;
}
int
axheard(ifp)
struct iface *ifp;
{
	int col = 0;
	struct lq *lp;
	char tmp[AXBUF];

	if(ifp->hwaddr == NULLCHAR)
		return 0;

	tputs(heardheader);
	tprintf(heardfmt,ifp->name,pax25(tmp,ifp->hwaddr),
	 tformat(secclock() - ifp->lastsent),ifp->rawsndcnt);

	tputs(heardheader2);
	for(lp = Lq;lp != NULLLQ;lp = lp->next){
		if(lp->iface != ifp)
			continue;
		if(col)
			tputs("  : ");
		if(tprintf("%-9s   %12s    %7lu",pax25(tmp,lp->addr),
		 tformat(secclock() - lp->time),lp->currxcnt) == EOF)
			return EOF;
		if(col){
			if(tputc('\n') == EOF){
				return EOF;
			} else {
				col = 0;
			}
		} else {
			col = 1;
		}
	}
	if(col)
		tputc('\n');
	return 0;
}
int
doaxdest(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	struct iface *ifp;

	if(argc > 1){
		if((ifp = if_lookup(argv[1])) == NULLIF){
            tprintf(Badinterface,argv[1]);
			return 1;
		}
		if(ifp->output != ax_output){
			tprintf(alsonotax25,argv[1]);
			return 1;
		}
		axdest(ifp);
		return 0;
	}
	for(ifp = Ifaces;ifp != NULLIF;ifp = ifp->next){
		if(ifp->output != ax_output)
			continue;	/* Not an ax.25 interface */
		if(axdest(ifp) == EOF)
			break;
	}
	return 0;
}
static int
axdest(ifp)
struct iface *ifp;
{
	struct ld *lp;
	struct lq *lq;
	char tmp[AXBUF];

	if(ifp->hwaddr == NULLCHAR)
		return 0;
	tprintf("%s:\n",ifp->name);
	tputs(destheader);
	for(lp = Ld;lp != NULLLD;lp = lp->next){
		if(lp->iface != ifp)
			continue;

		tprintf("%-10s%-17s",
		 pax25(tmp,lp->addr),tformat(secclock() - lp->time));

		if(addreq(lp->addr,ifp->hwaddr)){
			/* Special case; it's our address */
			tprintf(str17,tformat(secclock() - ifp->lastsent));
		} else if((lq = al_lookup(ifp,lp->addr,0)) == NULLLQ){
			tprintf(str17,"");
		} else {
			tprintf(str17,tformat(secclock() - lq->time));
		}
		if(tprintf("%8lu\n",lp->currxcnt) == EOF)
			return EOF;
	}
	return 0;
}

static int
doaxfilter(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	if(argc >= 2){
		setint(&axheard_filter_flag,heardfilter,argc,argv);
	} else {
		tputs(filterusage);
		return 1;
	}

	tprintf(filtersrc, (axheard_filter_flag & AXHEARD_NOSRC) ? "dis" : "en");
	tprintf(filterdest, (axheard_filter_flag & AXHEARD_NODST) ? "dis" : "en");
	return 0;
}

#ifdef POOLED
extern struct mempool lq_pool;
extern struct mempool ld_pool;
#endif

static int
doaxflush(argc,argv,p)
int argc OPTIONAL;
char *argv[] OPTIONAL;
void *p OPTIONAL;
{
struct iface *ifp;
#ifndef POOLED
struct lq *lp,*lp1;
struct ld *ld,*ld1;
#endif

	for(ifp = Ifaces;ifp != NULLIF;ifp = ifp->next){
		if(ifp->output != ax_output)
			continue;	/* Not an ax.25 interface */
		ifp->rawsndcnt = 0;
	}
#ifdef POOLED
	pool_free(&lq_pool);
#else
	for(lp = Lq;lp != NULLLQ;lp = lp1){
		lp1 = lp->next;
		free((char *)lp);
	}
#endif
	Lq = NULLLQ;
#ifdef POOLED
	pool_free(&ld_pool);
#else
	for(ld = Ld;ld != NULLLD;ld = ld1){
		ld1 = ld->next;
		free((char *)ld);
	}
#endif
	Ld = NULLLD;
	return 0;
}

static int
doaxreset(argc,argv,p)
int argc OPTIONAL;
char *argv[];
void *p OPTIONAL;
{
	struct ax25_cb *axp;

#ifndef TNOS_68K
	axp = MK_FP(htoi(argv[1]),8);
#else
	axp = htoi(argv[1]);
#endif
	if(!ax25val(axp)){
		tputs(Notval);
		return 1;
	}
	reset_ax25(axp);
	return 0;
}

/* Display AX.25 link level control blocks */
int
doaxstat(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
register struct ax25_cb *axp;
char tmp[AXBUF];
char tmp2[AXBUF];

	if(argc < 2)	{
		tputs(axstatheader);
		for(axp = Ax25_cb;axp != NULLAX25; axp = axp->next)	{
            if(tprintf(axstatfmt,FP_SEG(axp), len_q(axp->txq),len_p(axp->rxq),
		pax25(tmp,axp->remote), pax25(tmp2,axp->local),
                (axp->iface) ? axp->iface->name : "", Ax25states[axp->state]) == EOF)
			return 0;
		}
		return 0;
	}
#ifndef TNOS_68K
    axp = MK_FP(htoi(argv[1]),8);
#else
    axp = htoi(argv[1]);
#endif
    if(!ax25val(axp)){
		tputs(Notval);
		return 1;
	}
	st_ax25(axp);
	return 0;
}


/* Dump one control block */
void
st_ax25(axp)
register struct ax25_cb *axp;
{
	char tmp[AXBUF];
    char tmp2[AXBUF];

	if(axp == NULLAX25)
		return;
    tputs(axcbheader);
    tprintf(axcbfmt,FP_SEG(axp),
        pax25(tmp,axp->local),
        pax25(tmp2,axp->remote),
        (axp->iface) ? axp->iface->name : "",
        axp->flags.rejsent ? 'R' : ' ',
        axp->flags.remotebusy ? 'B' : ' ');
	tprintf(" %4d %4d",axp->vs,axp->vr);
	tprintf(" %02u/%02u %u",axp->unack,axp->maxframe,axp->proto);
	tprintf(" %02u/%02u",axp->retries,axp->n2);
	tprintf(" %s\n",Ax25states[axp->state]);
	tprintf(srttmdev,axp->srt,axp->mdev);
	tprintf(T1_4str, '1');
	if(run_timer(&axp->t1))
		tprintf(lustr,read_timer(&axp->t1));
	else
		tputs(stopstr);
	tprintf(lumsstr,dur_timer(&axp->t1));

	tprintf(T1_4str, '3');
	if(run_timer(&axp->t3))
		tprintf(lustr,read_timer(&axp->t3));
	else
		tputs(stopstr);
	tprintf(lumsstr,dur_timer(&axp->t3));

	tprintf(T1_4str, '4');
	if(run_timer(&axp->t4))
        tprintf(lustr,(read_timer(&axp->t4)/1000L));
	else
		tputs(stopstr);
    tprintf("/%lu sec\n",(dur_timer(&axp->t4)/1000L));
}

/* Set limit on retransmission backoff */
int
doax25blimit(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong((long *)p,blimitstr,argc,argv);
}
  
/* Set limit on retransmission backoff */
static int
doblimit(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25blimit(argc,argv,(void *)&Blimit);
}

/* Set limit on retransmission in ms */
int
doax25maxwait(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong((long *)p,maxwaitstr,argc,argv);
}
  
static int
doaxmaxwait(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
    return doax25maxwait(argc,argv,(void *)&Axmaxwait);
}
  
/* Display or change our AX.25 address */
static int
domycall(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
char tmp[AXBUF];

	if(argc < 2){
		tprintf(strCR,pax25(tmp,Mycall));
		return 0;
	}
	if(setcall(Mycall,argv[1]) == -1)
		return -1;
#ifdef MAILBOX
	setmbnrid();
#endif
	if (!memcmp (AXuser, NOCALL, AXALEN))
		setcall(AXuser,argv[1]);
	return 0;
}

#ifdef TTYCALL

/* Display or change ttylink AX.25 address */
static int
dottycall(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
    char tmp[AXBUF];

	if(argc < 2){
		tprintf(strCR,pax25(tmp,Ttycall));
		return 0;
	}
	if(setcall(Ttycall,argv[1]) == -1)
		return -1;
    return 0;
}

#endif


static int
doaxuser(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
    char tmp[AXBUF];

	if(argc < 2){
		tprintf(strCR,pax25(tmp,AXuser));
		return 0;
	}
	if(setcall(AXuser,argv[1]) == -1)
		return -1;
    return 0;
}


/* Control AX.25 digipeating */
static int
dodigipeat(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return(dosetflag(argc,argv,p,AX25_DIGI, 1));
}

int
doax25version(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,axversionstr,argc,argv);
}
  
static int
doaxversion(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25version(argc,argv,(void *)&Axversion);
}

static int
doax25irtt(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong((long *)p,irttstr,argc,argv);
}
  
static int
doaxirtt(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25irtt(argc,argv,(void *)&Axirtt);
}

/* Set idle timer */
int
doax25t3(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong((long *)p,polltimerstr,argc,argv);
}
  
/* Set idle timer */
static int
dot3(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25t3(argc,argv,&T3init);
}

/* Set link redundancy timer */
int
doax25t4(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setlong((long *)p,redundancystr,argc,argv);
}
  
/* Set link redundancy timer */
static int
dot4(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25t4(argc,argv,(long *)&T4init);
}

/* Set retry limit count */
int
doax25n2(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,retrylimitstr,argc,argv);
}
  
/* Set retry limit count */
static int
don2(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25n2(argc,argv,(void *)&N2);
}

/* Force a retransmission */
static int
doaxkick(argc,argv,p)
int argc OPTIONAL;
char *argv[];
void *p OPTIONAL;
{
	struct ax25_cb *axp;

#ifndef TNOS_68K
	axp = MK_FP(htoi(argv[1]),8);
#else
	axp = htoi(argv[1]);
#endif
	if(!ax25val(axp))	{
		tputs(Notval);
		return 1;
	}
	kick_ax25(axp);
	return 0;
}

/* Set maximum number of frames that will be allowed in flight */
int
doax25maxframe(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,maxframestr,argc,argv);
}
  
/* Set maximum number of frames that will be allowed in flight */
static int
domaxframe(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25maxframe(argc,argv,(void *)&Maxframe);
}

/* Set maximum length of I-frame data field */
int
doax25paclen(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,paclenstr,argc,argv);
}
  
/* Set maximum length of I-frame data field */
static int
dopaclen(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25paclen(argc,argv,(void *)&Paclen);
}

/* Set size of I-frame above which polls will be sent after a timeout */
int
doax25pthresh(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,pthreshstr,argc,argv);
}
  
/* Set size of I-frame above which polls will be sent after a timeout */
static int
dopthresh(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25pthresh(argc,argv,(void *)&Pthresh);
}

/* Set high water mark on receive queue that triggers RNR */
int
doax25window(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    return setshort((unsigned short *)p,windowstr,argc,argv);
}
  
/* Set high water mark on receive queue that triggers RNR */
static int
doaxwindow(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	return doax25window(argc,argv,(void *)&Axwindow);
}

/* End of ax25 subcommands */

/* Initiate interactive AX.25 connect to remote station */
int
doconnect(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	struct sockaddr_ax fsocket;
	struct session *sp;
	struct iface *ifp;
	int ndigis,i;
	char digis[MAXDIGIS][AXALEN];
	char target[AXALEN];
    int split = 0;
	char tmp[AXBUF];

	/*Make sure this comes from console - WG7J*/
    if(Curproc->input != Command->input)
		return 0;

#ifdef ALLSERV
    if(argv[0][0] == 's')   /* use split screen */
        split  = 1;
#endif

    if(((ifp = if_lookup(argv[1])) != NULLIF) && (ifp->type != CL_AX25)) {
		tprintf(alsonotax25,argv[1]);
		return 1;
	}
	if (ifp == NULLIF)	{
		tprintf(Badinterface,argv[1]);
#if defined(MAILBOX) && defined(GATECMDS)
		dombports (0, NULL, NULL);
#endif
		return 1;
	}

	if(argc > 3 && !strcmp(argv[3], "@"))	{
		free (argv[3]);
		argv[3] = strdup(pax25(tmp,AXRosecall));
	}
	if(setcall(target,argv[2]) == -1){
		tprintf(badcallsign, argv[2]);
		return 1;
	}

	/* If digipeaters are given, put them in the routing table */
	if(argc > 3){
		ndigis = argc - 3;
		if(ndigis > MAXDIGIS){
			tputs(toomany);
			return 1;
		}
		for(i=0;i<ndigis;i++){
			if(setcall(digis[i],argv[i+3]) == -1){
				tprintf(baddigi,argv[i+3]);
				return 1;
			}
		}
		if(ax_add(target,AX_AUTO,digis,ndigis,ifp) == NULLAXR){
			tputs(addfailed);
			return 1;
		}
	}
	/* Allocate a session descriptor */
	if((sp = newsession(argv[2],AX25TNC,split)) == NULLSESSION){
        tputs(TooManySessions);
		return 1;
	}
	if((sp->s = socket(AF_AX25,SOCK_STREAM,0)) == -1){
        tputs(Nosock);
		freesession(sp);
		keywait(NULLCHAR,1);
		return 1;
	}
	fsocket.sax_family = AF_AX25;
	memcpy(fsocket.ax25_addr, AXuser, AXALEN);
        bind(sp->s,(char *)&fsocket,sizeof(struct sockaddr_ax));
	setcall(fsocket.ax25_addr,argv[2]);
	strncpy(fsocket.iface,argv[1],ILEN-1);
	return tel_connect(sp, (char *)&fsocket, sizeof(struct sockaddr_ax));
}

/* Display and modify AX.25 routing table */
static int
doaxroute(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	char tmp[AXBUF];
	int i,ndigis;
	register struct ax_route *axr;
	char target[AXALEN],digis[MAXDIGIS][AXALEN];
	struct iface *iface;

	if(argc < 2){
		tputs(routeheader);
		for(axr = Ax_routes;axr != NULLAXR;axr = axr->next){
			tprintf("%-10s%-7s%-6s",pax25(tmp,axr->target),
				axr->iface->name,axr->type == AX_LOCAL ? "Local":"Auto");
			switch(axr->mode){
			case AX_VC_MODE:
				tputs(" VC ");
				break;
			case AX_DATMODE:
				tputs(" DG ");
				break;
			case AX_DEFMODE:
				tputs(" IF ");
				break;
			default:
				tputs(" ?? ");
				break;
			}

			for(i=0;i<axr->ndigis;i++){
				tprintf(" %s",pax25(tmp,axr->digis[i]));
			}
			if(tputc('\n') == EOF)
				return 0;
		}
		return 0;
	}
	if(argc < 4){
		tputs(routeusage);
		return 1;
	}
	if(setcall(target,argv[2]) == -1){
		tprintf(badtarget,argv[2]);
		return 1;
	}
	if((iface = if_lookup(argv[3])) == NULLIF){
		tprintf(Badinterface,argv[3]);
		return 1;
	}
	switch(argv[1][0]){
	case 'a':	/* Add route */
		ndigis = argc - 4;
		if(ndigis > MAXDIGIS){
			tputs(toomany);
			return 1;
		}
		for(i=0;i<ndigis;i++){
			if(setcall(digis[i],argv[i+4]) == -1){
				tprintf(baddigi,argv[i+4]);
				return 1;
			}
		}
		if(ax_add(target,AX_LOCAL,digis,ndigis,iface) == NULLAXR){
			tputs(addfailed);
			return 1;
		}
		break;
	case 'd':	/* Drop route */
		if(ax_drop(target,iface) == -1){
			tputs(notintable);
			return 1;
		}
		break;
	case 'm':	/* Alter route mode */
		if((axr = ax_lookup(target,iface)) == NULLAXR){
			tputs(notintable);
			return 1;
		}
		switch(argv[4][0]){
		case 'i':	/* use default interface mode */
			axr->mode = AX_DEFMODE;
			break;
		case 'v':	/* use virtual circuit mode */
			axr->mode = AX_VC_MODE;
			break;
		case 'd':	/* use datagram mode */
			axr->mode = AX_DATMODE;
			break;
		default:
			tprintf(unknownmode, argv[4]);
			return 1;
		}
		break;
	default:
		tprintf(unknowncmd,argv[1]);
		return 1;
	}
	return 0;
}

/* ax25 timers type - linear v exponential */
int
doax25timertype(argc,argv,p)
int argc ;
char *argv[] ;
void *p ;
{

	if (argc < 2) {
		tputs(timertypestr);
		switch(*(int *)p){
		case 2:
			tputs(originalstr);
			break;
		case 1:
			tputs(linearstr);
			break;
		case 0:
			tputs(exponentialstr);
			break;
		}
		return 0 ;
	}
	
	switch (argv[1][0]) {
		case 'o':
		case 'O':
			*(int *)p = 2 ;
			break ;
		case 'l':
		case 'L':
			*(int *)p = 1 ;
			break ;
		case 'e':
		case 'E':
			*(int *)p = 0 ;
			break ;
		default:
			tputs(timertypeusage) ;
			return -1 ;
	}

	return 0 ;
}

/* ax25 timers type - linear v exponential */
static int
doaxtype(argc,argv,p)
int argc ;
char *argv[] ;
void *p OPTIONAL;
{
    return doax25timertype(argc,argv,(void *)&lapbtimertype);
}
  
  
/* Display or change an AX.25 tutorial-type call */
static int
docall(argc,argv,p, call)
int argc;
char *argv[];
void *p OPTIONAL;
char call[];
{
char tmp[AXBUF];

	if(argc < 2)	{
		tprintf(strCR,pax25(tmp,call));
		return 0;
	}
	if(setcall(call,argv[1]) == -1)
		return -1;
	return 0;
}


/* Display or change our AX.25 rose entry call */
static int
dorosecall(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return (docall (argc, argv, p, AXRosecall));
}

#ifdef TUTOR
/* Display or change our AX.25 tutorial call */
static int
dotutorcall(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return (docall (argc, argv, p, Tcall));
}


/* Display or change our AX.25 info call */
static int
doinfocall(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return (docall (argc, argv, p, Icall));
}


/* Display or change our AX.25 news call */
static int
donewscall(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return (docall (argc, argv, p, Ncall));
}
#endif

void init_ifax25(struct ifax25 *ax25) {
  
    if(!ax25)
        return;
    /* Set interface to the defaults */
    ax25->paclen = Paclen;
    ax25->lapbtimertype = lapbtimertype;
    ax25->irtt = Axirtt;
    ax25->version = Axversion;
    ax25->t3 = T3init;
    ax25->t4 = T4init;
    ax25->n2 = N2;
    ax25->maxframe = Maxframe;
    ax25->pthresh = Pthresh;
    ax25->window = Axwindow;
    ax25->blimit = Blimit;
    ax25->maxwait = Axmaxwait;
    if(axbctext)
        ax25->bctext = strdup(axbctext);
}
  
static int doifax25paclen __ARGS((int argc, char *argv[], void *p));
static int doifax25timertype __ARGS((int argc, char *argv[], void *p));
static int doifax25irtt __ARGS((int argc, char *argv[], void *p));
static int doifax25version __ARGS((int argc, char *argv[], void *p));
static int doifax25t3 __ARGS((int argc, char *argv[], void *p));
static int doifax25t4 __ARGS((int argc, char *argv[], void *p));
static int doifax25n2 __ARGS((int argc, char *argv[], void *p));
static int doifax25maxframe __ARGS((int argc, char *argv[], void *p));
static int doifax25pthresh __ARGS((int argc, char *argv[], void *p));
static int doifax25window __ARGS((int argc, char *argv[], void *p));
static int doifax25blimit __ARGS((int argc, char *argv[], void *p));
static int doifax25maxwait __ARGS((int argc, char *argv[], void *p));
static int doifax25bctext __ARGS((int argc, char *argv[], void *p));
  
/* These are the command that set ax.25 parameters per interface */
static struct cmds DFAR Ifaxcmds[] = {
	{ "bctext",	doifax25bctext,		0, 0, NULLCHAR },
	{ "blimit",	doifax25blimit,		0, 0, NULLCHAR },
	{ "irtt",	doifax25irtt,		0, 0, NULLCHAR },
	{ "maxframe",	doifax25maxframe,	0, 0, NULLCHAR },
	{ "maxwait",	doifax25maxwait,	0, 0, NULLCHAR },
	{ "paclen",	doifax25paclen,		0, 0, NULLCHAR },
	{ "pthresh",	doifax25pthresh,	0, 0, NULLCHAR },
	{ "retry",	doifax25n2,		0, 0, NULLCHAR },
	{ "timertype",	doifax25timertype,	0, 0, NULLCHAR },
	{ "t3",		doifax25t3,		0, 0, NULLCHAR },
	{ "t4",		doifax25t4,		0, 0, NULLCHAR },
	{ "version",	doifax25version,	0, 0, NULLCHAR },
	{ "window",	doifax25window,		0, 0, NULLCHAR },
	{ NULLCHAR,	NULL,			0, 0, NULLCHAR }
};
  
int ifax25(int argc,char *argv[],void *p) {
  
    if(((struct iface *)p)->type != CL_AX25)
        return tputs(notax25);
    return subcmd(Ifaxcmds,argc,argv,p);
};
  
  
  
/* Set ax.25 bctext */
static int
doifax25bctext(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    if(argc == 1)
        tprintf(bctext_str,ifp->ax25->bctext);
    else {
        if(ifp->ax25->bctext)
            free(ifp->ax25->bctext);
        if(strlen(argv[1]) == 0)    /* clearing the buffer */
            ifp->ax25->bctext = NULL;
        else
            ifp->ax25->bctext = strdup(argv[1]);
    }
    return 0;
}
  
static int
doifax25blimit(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25blimit(argc,argv,(void *)&ifp->ax25->blimit);
}
  
static int
doifax25irtt(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25irtt(argc,argv,(void *)&ifp->ax25->irtt);
}
  
static int
doifax25maxframe(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25maxframe(argc,argv,(void *)&ifp->ax25->maxframe);
}
  
static int
doifax25maxwait(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25maxwait(argc,argv,(void *)&ifp->ax25->maxwait);
}
  
  
/* Set interface AX.25 Paclen, and adjust the NETROM mtu for the
 * smallest paclen. - WG7J
 */
static int
doifax25paclen(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
#ifdef NETROM
    int tmp;
#endif
  
    doax25paclen(argc,argv,(void *)&ifp->ax25->paclen);
#ifdef NETROM
    if(argc > 1 && ifp->flags & IS_NR_IFACE) {
        if((tmp=ifp->ax25->paclen - 20) < Nr_iface->mtu)
            Nr_iface->mtu = tmp;
    }
#endif
    return 0;
}
  
static int
doifax25pthresh(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25pthresh(argc,argv,(void *)&ifp->ax25->pthresh);
}
  
static int
doifax25n2(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25n2(argc,argv,(void *)&ifp->ax25->n2);
}
  
static int
doifax25timertype(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25timertype(argc,argv,(void *)&ifp->ax25->lapbtimertype);
}
  
static int
doifax25t3(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25t3(argc,argv,(void *)&ifp->ax25->t3);
}
  
static int
doifax25t4(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25t4(argc,argv,(void *)&ifp->ax25->t4);
}
  
static int
doifax25version(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25version(argc,argv,(void *)&ifp->ax25->version);
}
  
static int
doifax25window(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct iface *ifp = p;
  
    return doax25window(argc,argv,(void *)&ifp->ax25->window);
}
  
#endif /* AX25 */
