/* PBBS Import file client
 * Copyright 1995 Brian A. Lantz, KO4KS
 */
#include <ctype.h>
#include <string.h>
#include "global.h"
#ifdef BBSIMPORT
#include "mbuf.h"
#include "socket.h"
#include "session.h"
#include "proc.h"
#include "netuser.h"
#include "commands.h"
#include "tty.h"
#include "timer.h"
#include "mailbox.h"
#include "files.h"
#include "smtp.h"
#ifdef MSDOS
#include <dir.h>
#endif


void importcmd __ARGS((int mode));
int doimport __ARGS((int argc,char *argv[],void *p));
void importtick __ARGS((void *p));

static struct timer importtimer;
#define MSPMINUTE (1000L*60L)


int
doimport(argc,argv,p)
int argc;
char *argv[];
void *p OPTIONAL;
{
	if(argc < 2){
		tprintf("import timer: %lu/%lu minutes\n",
			read_timer(&importtimer)/MSPMINUTE,
			dur_timer(&importtimer)/MSPMINUTE);
		return 0;
	}
	if(*argv[1] == 'n') {
		importtick(NULL);
		return 0;
	}
	stop_timer (&importtimer);	/* just in case */
	importtimer.func = (void (*)__ARGS((void *)))importtick;/* what to call on timeout */
	importtimer.arg = NULL;		/* dummy value */
	set_timer(&importtimer,atol(argv[1])*MSPMINUTE); /* set timer duration */
	start_timer(&importtimer);     /* fire it up */
	return 0;
}

void
importtick(p)
void *p OPTIONAL;
{
    start_timer(&importtimer);
    /* Spawn off the process */
    if (newproc("BBS import",(unsigned)1024,(void (*)__ARGS((int,void*,void*)))importcmd,0,(void *)0,(void *)0,0) == NULLPROC)
	log (-1, "Couldn't start Import process");
}

void
importcmd(mode)
int mode;
{
struct mbx *m;
char buf[80], tempname[1024];
struct ffblk ff;
int oldoutput;
int result = 0;

	m = newmbx (1);
	oldoutput = Curproc->output;
	Curproc->output = 0;
	m->user = Curproc->output;
	m->ps = Curproc;
	m->state = MBX_FORWARD;
	m->sid = MBX_SID;
	strcpy (m->name, "import");

	if (!mode)	{
		sprintf(buf,"%s/*.imp",IMPORTDir);
		result = findfirst(buf, &ff, 0);
	}
	if (!result)	{
		do	{
			pwait(NULL);    /* Let others run */
			if (mode)
				sprintf (tempname, "%s/import.txt", Mailspool);
			else
				sprintf (tempname, "%s/%s", IMPORTDir, ff.ff_name);
			if ((m->quickfile = fopen (tempname, READ_TEXT)) != NULLFILE)	{
				while (!feof(m->quickfile))	{
					m->change = 0;
					fgets (m->line, MBXLINE, m->quickfile);
					if (feof(m->quickfile))
						continue;
					rip (m->line);
					if (tolower(*m->line) != 's' || m->line[2] != ' ')
						continue;
					mbx_parse(m);
					if (!m->change)	{	/* skip till '/EX' */
						while (!feof(m->quickfile))	{
							fgets (m->line, MBXLINE, m->quickfile);
							if (feof(m->quickfile))
								continue;
							if (!strnicmp (m->line, "/ex", 3))
								break;
						}
					}
				}
				fclose (m->quickfile);
#if 1
				unlink (tempname);
#endif
			}
		if (!mode)
			result = findnext(&ff);
		else
			result = 1;
			
		} while (!result);
	}

	smtptick(NULL);		/* wake SMTP to send that mail */
	Curproc->output = oldoutput;
	m->change = 0;
	exitbbs(m);
	return;
}

#endif /* BBSIMPORT */
